const var_type_map = Dict(
KTR_VARTYPE_CONTINUOUS => :Cont,
KTR_VARTYPE_INTEGER => :Int,
KTR_VARTYPE_BINARY => :Bin
)

const rev_var_type_map = Dict(
:Cont => KTR_VARTYPE_CONTINUOUS,
:Int => KTR_VARTYPE_INTEGER,
:Bin => KTR_VARTYPE_BINARY
)

# This list was obtained through AWK with Knitro 11.0 with the following command:
# grep "#define" include/ktr.h | grep "KTR_PARAM_" | awk '{ printf("\"%s\" => Int32(%s),\n",$2,$3) }'
# For versions up to 10.3, use the folowing command:
# grep "#define" knitro.h | grep "KTR_PARAM_" | awk '{ printf("\"%s\" => Int32(%s),\n",$2,$3) }'
const paramName2Indx = Dict(
"KTR_PARAM_NEWPOINT" => Int32(1001),
"KTR_PARAM_HONORBNDS" => Int32(1002),
"KTR_PARAM_ALGORITHM" => Int32(1003),
"KTR_PARAM_ALG" => Int32(1003),
"KTR_PARAM_BAR_MURULE" => Int32(1004),
"KTR_PARAM_BARRULE" => Int32(1004),
"KTR_PARAM_BAR_FEASIBLE" => Int32(1006),
"KTR_PARAM_FEASIBLE" => Int32(1006),
"KTR_PARAM_GRADOPT" => Int32(1007),
"KTR_PARAM_HESSOPT" => Int32(1008),
"KTR_PARAM_BAR_INITPT" => Int32(1009),
"KTR_PARAM_ACT_LPSOLVER" => Int32(1012),
"KTR_PARAM_LPSOLVER" => Int32(1012),
"KTR_PARAM_CG_MAXIT" => Int32(1013),
"KTR_PARAM_MAXCGIT" => Int32(1013),
"KTR_PARAM_MAXIT" => Int32(1014),
"KTR_PARAM_OUTLEV" => Int32(1015),
"KTR_PARAM_OUTMODE" => Int32(1016),
"KTR_PARAM_SCALE" => Int32(1017),
"KTR_PARAM_SHIFTINIT" => Int32(1018),
"KTR_PARAM_SOC" => Int32(1019),
"KTR_PARAM_DELTA" => Int32(1020),
"KTR_PARAM_BAR_FEASMODETOL" => Int32(1021),
"KTR_PARAM_FEASMODETOL" => Int32(1021),
"KTR_PARAM_FEASTOL" => Int32(1022),
"KTR_PARAM_FEASTOLABS" => Int32(1023),
"KTR_PARAM_MAXTIMECPU" => Int32(1024),
"KTR_PARAM_BAR_INITMU" => Int32(1025),
"KTR_PARAM_MU" => Int32(1025),
"KTR_PARAM_OBJRANGE" => Int32(1026),
"KTR_PARAM_OPTTOL" => Int32(1027),
"KTR_PARAM_OPTTOLABS" => Int32(1028),
"KTR_PARAM_LINSOLVER_PIVOTTOL" => Int32(1029),
"KTR_PARAM_PIVOT" => Int32(1029),
"KTR_PARAM_XTOL" => Int32(1030),
"KTR_PARAM_DEBUG" => Int32(1031),
"KTR_PARAM_MULTISTART" => Int32(1033),
"KTR_PARAM_MSENABLE" => Int32(1033),
"KTR_PARAM_MSMAXSOLVES" => Int32(1034),
"KTR_PARAM_MSMAXBNDRANGE" => Int32(1035),
"KTR_PARAM_MSMAXTIMECPU" => Int32(1036),
"KTR_PARAM_MSMAXTIMEREAL" => Int32(1037),
"KTR_PARAM_LMSIZE" => Int32(1038),
"KTR_PARAM_BAR_MAXCROSSIT" => Int32(1039),
"KTR_PARAM_MAXCROSSIT" => Int32(1039),
"KTR_PARAM_MAXTIMEREAL" => Int32(1040),
"KTR_PARAM_CG_PRECOND" => Int32(1041),
"KTR_PARAM_BLASOPTION" => Int32(1042),
"KTR_PARAM_BAR_MAXREFACTOR" => Int32(1043),
"KTR_PARAM_BAR_MAXBACKTRACK" => Int32(1044),
"KTR_PARAM_LINESEARCH_MAXTRIALS" => Int32(1044),
"KTR_PARAM_BLASOPTIONLIB" => Int32(1045),
"KTR_PARAM_OUTAPPEND" => Int32(1046),
"KTR_PARAM_OUTDIR" => Int32(1047),
"KTR_PARAM_CPLEXLIB" => Int32(1048),
"KTR_PARAM_BAR_PENRULE" => Int32(1049),
"KTR_PARAM_BAR_PENCONS" => Int32(1050),
"KTR_PARAM_MSNUMTOSAVE" => Int32(1051),
"KTR_PARAM_MSSAVETOL" => Int32(1052),
"KTR_PARAM_PRESOLVEDEBUG" => Int32(1053),
"KTR_PARAM_MSTERMINATE" => Int32(1054),
"KTR_PARAM_MSSTARTPTRANGE" => Int32(1055),
"KTR_PARAM_INFEASTOL" => Int32(1056),
"KTR_PARAM_LINSOLVER" => Int32(1057),
"KTR_PARAM_BAR_DIRECTINTERVAL" => Int32(1058),
"KTR_PARAM_PRESOLVE" => Int32(1059),
"KTR_PARAM_PRESOLVE_TOL" => Int32(1060),
"KTR_PARAM_BAR_SWITCHRULE" => Int32(1061),
"KTR_PARAM_HESSIAN_NO_F" => Int32(1062),
"KTR_PARAM_MA_TERMINATE" => Int32(1063),
"KTR_PARAM_MA_MAXTIMECPU" => Int32(1064),
"KTR_PARAM_MA_MAXTIMEREAL" => Int32(1065),
"KTR_PARAM_MSSEED" => Int32(1066),
"KTR_PARAM_MA_OUTSUB" => Int32(1067),
"KTR_PARAM_MS_OUTSUB" => Int32(1068),
"KTR_PARAM_XPRESSLIB" => Int32(1069),
"KTR_PARAM_TUNER" => Int32(1070),
"KTR_PARAM_TUNER_OPTIONSFILE" => Int32(1071),
"KTR_PARAM_TUNER_MAXTIMECPU" => Int32(1072),
"KTR_PARAM_TUNER_MAXTIMEREAL" => Int32(1073),
"KTR_PARAM_TUNER_OUTSUB" => Int32(1074),
"KTR_PARAM_TUNER_TERMINATE" => Int32(1075),
"KTR_PARAM_LINSOLVER_OOC" => Int32(1076),
"KTR_PARAM_BAR_RELAXCONS" => Int32(1077),
"KTR_PARAM_MSDETERMINISTIC" => Int32(1078),
"KTR_PARAM_BAR_REFINEMENT" => Int32(1079),
"KTR_PARAM_DERIVCHECK" => Int32(1080),
"KTR_PARAM_DERIVCHECK_TYPE" => Int32(1081),
"KTR_PARAM_DERIVCHECK_TOL" => Int32(1082),
"KTR_PARAM_LINSOLVER_INEXACT" => Int32(1083),
"KTR_PARAM_LINSOLVER_INEXACTTOL" => Int32(1084),
"KTR_PARAM_MAXFEVALS" => Int32(1085),
"KTR_PARAM_FSTOPVAL" => Int32(1086),
"KTR_PARAM_DATACHECK" => Int32(1087),
"KTR_PARAM_DERIVCHECK_TERMINATE" => Int32(1088),
"KTR_PARAM_BAR_WATCHDOG" => Int32(1089),
"KTR_PARAM_FTOL" => Int32(1090),
"KTR_PARAM_FTOL_ITERS" => Int32(1091),
"KTR_PARAM_ACT_QPALG" => Int32(1092),
"KTR_PARAM_BAR_INITPI_MPEC" => Int32(1093),
"KTR_PARAM_XTOL_ITERS" => Int32(1094),
"KTR_PARAM_LINESEARCH" => Int32(1095),
"KTR_PARAM_OUT_CSVINFO" => Int32(1096),
"KTR_PARAM_INITPENALTY" => Int32(1097),
"KTR_PARAM_ACT_LPFEASTOL" => Int32(1098),
"KTR_PARAM_CG_STOPTOL" => Int32(1099),
"KTR_PARAM_RESTARTS" => Int32(1100),
"KTR_PARAM_RESTARTS_MAXIT" => Int32(1101),
"KTR_PARAM_BAR_SLACKBOUNDPUSH" => Int32(1102),
"KTR_PARAM_CG_PMEM" => Int32(1103),
"KTR_PARAM_BAR_SWITCHOBJ" => Int32(1104),
"KTR_PARAM_OUTNAME" => Int32(1105),
"KTR_PARAM_OUT_CSVNAME" => Int32(1106),
"KTR_PARAM_ACT_PARAMETRIC" => Int32(1107),
"KTR_PARAM_ACT_LPDUMPMPS" => Int32(1108),
"KTR_PARAM_ACT_LPALG" => Int32(1109),
"KTR_PARAM_ACT_LPPRESOLVE" => Int32(1110),
"KTR_PARAM_ACT_LPPENALTY" => Int32(1111),
"KTR_PARAM_CONVEX_TUNE" => Int32(1114),
"KTR_PARAM_OUT_HINTS" => Int32(1115),
"KTR_PARAM_MIP_METHOD" => Int32(2001),
"KTR_PARAM_MIP_BRANCHRULE" => Int32(2002),
"KTR_PARAM_MIP_SELECTRULE" => Int32(2003),
"KTR_PARAM_MIP_INTGAPABS" => Int32(2004),
"KTR_PARAM_MIP_INTGAPREL" => Int32(2005),
"KTR_PARAM_MIP_MAXTIMECPU" => Int32(2006),
"KTR_PARAM_MIP_MAXTIMEREAL" => Int32(2007),
"KTR_PARAM_MIP_MAXSOLVES" => Int32(2008),
"KTR_PARAM_MIP_INTEGERTOL" => Int32(2009),
"KTR_PARAM_MIP_OUTLEVEL" => Int32(2010),
"KTR_PARAM_MIP_OUTINTERVAL" => Int32(2011),
"KTR_PARAM_MIP_OUTSUB" => Int32(2012),
"KTR_PARAM_MIP_DEBUG" => Int32(2013),
"KTR_PARAM_MIP_IMPLICATNS" => Int32(2014),
"KTR_PARAM_MIP_GUB_BRANCH" => Int32(2015),
"KTR_PARAM_MIP_KNAPSACK" => Int32(2016),
"KTR_PARAM_MIP_ROUNDING" => Int32(2017),
"KTR_PARAM_MIP_ROOTALG" => Int32(2018),
"KTR_PARAM_MIP_LPALG" => Int32(2019),
"KTR_PARAM_MIP_TERMINATE" => Int32(2020),
"KTR_PARAM_MIP_MAXNODES" => Int32(2021),
"KTR_PARAM_MIP_HEURISTIC" => Int32(2022),
"KTR_PARAM_MIP_HEUR_MAXIT" => Int32(2023),
"KTR_PARAM_MIP_HEUR_MAXTIMECPU" => Int32(2024),
"KTR_PARAM_MIP_HEUR_MAXTIMEREAL" => Int32(2025),
"KTR_PARAM_MIP_PSEUDOINIT" => Int32(2026),
"KTR_PARAM_MIP_STRONG_MAXIT" => Int32(2027),
"KTR_PARAM_MIP_STRONG_CANDLIM" => Int32(2028),
"KTR_PARAM_MIP_STRONG_LEVEL" => Int32(2029),
"KTR_PARAM_MIP_INTVAR_STRATEGY" => Int32(2030),
"KTR_PARAM_MIP_RELAXABLE" => Int32(2031),
"KTR_PARAM_MIP_NODEALG" => Int32(2032),
"KTR_PARAM_MIP_HEUR_TERMINATE" => Int32(2033),
"KTR_PARAM_MIP_SELECTDIR" => Int32(2034),
"KTR_PARAM_PAR_NUMTHREADS" => Int32(3001),
"KTR_PARAM_PAR_CONCURRENT_EVALS" => Int32(3002),
"KTR_PARAM_PAR_BLASNUMTHREADS" => Int32(3003),
"KTR_PARAM_PAR_LSNUMTHREADS" => Int32(3004),
"KTR_PARAM_PAR_MSNUMTHREADS" => Int32(3005),
)
